Dim Shared As Integer winkel=0 
Type spielfeld_type
	As Double zeit
	As Integer field(0 To fieldrange,0 To fieldrange)
	As Integer visible(0 To fieldrange,0 To fieldrange)
	As Integer size=fieldsize
	Declare Sub _paint 
	Declare Function Add(x As Integer,y As Integer,richtung As Integer,size As Integer,set As Integer=0) As Integer
	Declare Function won(title As String) As integer
End Type

'Gibt das Spielfeld auf den Bildschirm aus
Sub spielfeld_type._paint
	If Timer-zeit>0.01 Then
		zeit=Timer
		winkel+=1
		If winkel>180 Then winkel=0
	EndIf

	For i As Integer = 0 To windowxy
		For j As Integer = 0 To windowxy
			If i Mod size = 0 Or j Mod size = 0 Then
				Dim As Integer col
				col=Abs(winkel- (90-aTn(((windowxy/2)-i)/(windowxy-j))*180/(ACos(0)*2)))*0.5
				If col<1 Then col=1
				Color RGB(0,255/col,0)
				PSet (i,j)

			End If
		Next
	Next

	For i As Integer = 0 To windowxy/size-1
		For j As Integer = 0 To windowxy/size-1	
			If this.field(i,j)<>0  Then
				Dim As Integer col
				col=Abs(winkel- (90-aTn(((windowxy/2)-i*size)/(windowxy-j*size))*180/(ACos(0)*2)))*0.5
				If col<1 Then col=1
				If myworld=1  Then Draw String (i*size+size/2-3,j*size+size/2-3),Str(this.field(i,j)-1),RGB(0,255/col,0)
				If this.visible(i,j)=1  Then
					Dim As Integer col2=50+255/col
					If col2>255 Then col2=255
					Draw String (i*size+size/2-3,j*size+size/2-3),Str(this.field(i,j)-1),RGB(0,col2,0)
				EndIf
			End if
			
		Next
	Next
End Sub

'Gibt zurck, ob ein Schiff der Lnge Shipsize auf Position (x,y) passt und setzt es entsprechend bei set=1
function spielfeld_type.add(x As Integer,y As Integer,richtung As Integer,Shipsize As Integer,set As Integer=0) As Integer
	shipsize-=1
	If this.field(x,y)<>0 Then Return 0
	If set=0 then
		Select Case richtung
			Case 1 'rechts
				For j As Integer = -1 To 1
					For i As Integer = -1 To Shipsize+1
						If y+j<0 Then Return 0 
						If y+j>(fieldrange) Then Return 0 
						If x+i>(fieldrange) Then Return 0
						If this.field(x+i,y+j)<>0 Then Return 0
					Next
				Next
			Case 2 'unten
				For j As Integer = -1 To 1
					For i As Integer = -1 To Shipsize+1
						If y+j<0 Then Return 0 
						If x+j>(fieldrange) Then Return 0 
						If y+i>(fieldrange) Then Return 0
						If this.field(x+j,y+i)<>0 Then Return 0
					Next
				Next
		End Select
		
		Return 1
	Else
		
		this.field(x,y)=1+Val(Mid( Str( Bin(Shipsize+1,Shipsize+1) ),1,1)) 'ship.bild(0)
		Select Case richtung
			Case 1 'rechts
				For i As Integer = 1 To Shipsize
					this.field(x+i,y)=1+Val(Mid( Str( Bin(Shipsize+1,Shipsize+1) ),1+i,1))'ship.bild(i)
				Next
			Case 2 'unten
				For i As Integer = 1 To Shipsize
					this.field(x,y+i)=1+Val(Mid( Str( Bin(Shipsize+1,Shipsize+1) ),1+i,1))'ship.bild(i)
				Next
		End Select
		Return 1
	End if
		
End Function

'Gibt zurck, ob alle belegten Felder aufgedeckt wurden (spiel beenden)
Function spielfeld_type.won(title As String) As integer
	For i As Integer = 0 To fieldrange
		For j As Integer = 0 To fieldrange
			If this.field(i,j)<>0 And this.visible(i,j)=0 Then Return 0
		Next
	Next
	'Finish
	ScreenUnLock
	Dim As String outputString=title+" won! Press ESC!"
	Do
		ScreenLock
		cls	
		this._paint
		
		Draw String((windowxy/2)-Len(outputString)/2*8,250),outputString,RGB(0,255,0)
		Line ((windowxy/2)-Len(outputString)/2*8,260)-((windowxy/2)+(Len(outputString)-1)/2*8,260),RGB(0,255,0)
		Line ((windowxy/2)-Len(outputString)/2*8+2,262)-((windowxy/2)+(Len(outputString)-1)/2*8-2,262),RGB(0,255,0)
		ScreenUnLock
		Sleep 1,1	
	Loop Until MultiKey(1)
	Return 1
End Function
